//
//  MBProgressHUD+Addtions.h
//  RealEstateManagement
//
//  Created by Z on 16/6/24.
//  Copyright © 2016年 上海勾芒信息科技. All rights reserved.
//

#import <MBProgressHUD/MBProgressHUD.h>

@interface MBProgressHUD (Addtions)

/**
 *  展示成功信息 自动消失
 *
 *  @param success  显示文字
 *  @param complete 完成回调
 */
+ (void)j_success:(NSString *)success complete:(void (^)(void))complete;

/**
 *  展示失败信息 自动消失
 *
 *  @param error  提示文字
 *  @param complete 完成回调
 */
+ (void)j_error:(NSString *)error complete:(void (^)(void))complete;

/**
 *  只有菊花
 */
+ (void)j_loading;

/**
 *  只有菊花
 */
+ (MBProgressHUD *)j_loadingOnView:(UIView *)view;

/**
 *  菊花+文字
 *
 *  @param text 提示文字
 */
+ (void)j_loading:(NSString *)text;

/**
 *  菊花+文字
 */
+ (MBProgressHUD *)j_loadingOnView:(UIView *)view text:(NSString *)text;

/**
 *  文字提示 自动消失
 *
 *  @param text 仅提示文字
 */
+ (void)j_textOnly:(NSString *)text;

/**
 *  隐藏kwindow上面的所有hud
 */
+ (void)j_hideLoadingView;

+ (void)j_hideOnView:(UIView *)view;

+ (void)j_warningMessage:(NSString *)msg;
@end
